
<!DOCTYPE html>

<html class="no-js" lang="en">
<head>
<meta charset="utf-8"/>
<meta content="width=device-width,initial-scale=1" name="viewport"/>
<link href="../assets/images/favicon.png" rel="icon"/>
<meta content="mkdocs-1.2.3, mkdocs-material-7.3.6" name="generator"/>
<title>Architecture - SecuWallet</title>
<link href="../assets/stylesheets/main.a57b2b03.min.css" rel="stylesheet"/>
<link href="../assets/stylesheets/palette.3f5d1f46.min.css" rel="stylesheet"/>
<meta content="#ab47bd" name="theme-color"/>
<link crossorigin="" href="https://fonts.gstatic.com" rel="preconnect"/>
<link href="https://fonts.googleapis.com/css?family=Roboto:300,400,400i,700%7CRoboto+Mono&amp;display=fallback" rel="stylesheet"/>
<style>:root{--md-text-font-family:"Roboto";--md-code-font-family:"Roboto Mono"}</style>
<link href="https://unpkg.com/mermaid@8.5.1/dist/mermaid.css" rel="stylesheet"/>
<link href="../extra.css" rel="stylesheet"/>
</head>
<body data-md-color-accent="" data-md-color-primary="purple" data-md-color-scheme="slate" dir="ltr">
<script>function __prefix(e){return new URL("..",location).pathname+"."+e}function __get(e,t=localStorage){return JSON.parse(t.getItem(__prefix(e)))}</script>
<input autocomplete="off" class="md-toggle" data-md-toggle="drawer" id="__drawer" type="checkbox"/>
<input autocomplete="off" class="md-toggle" data-md-toggle="search" id="__search" type="checkbox"/>
<label class="md-overlay" for="__drawer"></label>
<div data-md-component="skip">
<a class="md-skip" href="#architecture">
          Skip to content
        </a>
</div>
<div data-md-component="announce">
</div>
<header class="md-header" data-md-component="header">
<nav aria-label="Header" class="md-header__inner md-grid">
<a aria-label="SecuWallet" class="md-header__button md-logo" data-md-component="logo" href=".." title="SecuWallet">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54z"></path></svg>
</a>
<label class="md-header__button md-icon" for="__drawer">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2z"></path></svg>
</label>
<div class="md-header__title" data-md-component="header-title">
<div class="md-header__ellipsis">
<div class="md-header__topic">
<span class="md-ellipsis">
            SecuWallet
          </span>
</div>
<div class="md-header__topic" data-md-component="header-topic">
<span class="md-ellipsis">
            
              Architecture
            
          </span>
</div>
</div>
</div>
<label class="md-header__button md-icon" for="__search">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5z"></path></svg>
</label>
<div class="md-search" data-md-component="search" role="dialog">
<label class="md-search__overlay" for="__search"></label>
<div class="md-search__inner" role="search">
<form class="md-search__form" name="search">
<input aria-label="Search" autocapitalize="off" autocomplete="off" autocorrect="off" class="md-search__input" data-md-component="search-query" name="query" placeholder="Search" required="" spellcheck="false" type="text"/>
<label class="md-search__icon md-icon" for="__search">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5z"></path></svg>
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12z"></path></svg>
</label>
<nav aria-label="Search" class="md-search__options">
<button aria-label="Clear" class="md-search__icon md-icon" tabindex="-1" type="reset">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41z"></path></svg>
</button>
</nav>
</form>
<div class="md-search__output">
<div class="md-search__scrollwrap" data-md-scrollfix="">
<div class="md-search-result" data-md-component="search-result">
<div class="md-search-result__meta">
            Initializing search
          </div>
<ol class="md-search-result__list"></ol>
</div>
</div>
</div>
</div>
</div>
</nav>
</header>
<div class="md-container" data-md-component="container">
<main class="md-main" data-md-component="main">
<div class="md-main__inner md-grid">
<div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation">
<div class="md-sidebar__scrollwrap">
<div class="md-sidebar__inner">
<nav aria-label="Navigation" class="md-nav md-nav--primary" data-md-level="0">
<label class="md-nav__title" for="__drawer">
<a aria-label="SecuWallet" class="md-nav__button md-logo" data-md-component="logo" href=".." title="SecuWallet">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54z"></path></svg>
</a>
    SecuWallet
  </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../0_Poster/">
        Poster
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../1_Resume/">
        Introduction
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../2_CahierDesCharges/">
        Cahier des charges
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../3_planning/">
        Planning
      </a>
</li>
<li class="md-nav__item md-nav__item--active md-nav__item--nested">
<input checked="" class="md-nav__toggle md-toggle" data-md-toggle="__nav_5" id="__nav_5" type="checkbox"/>
<label class="md-nav__link" for="__nav_5">
          Documentation technique
          <span class="md-nav__icon md-icon"></span>
</label>
<nav aria-label="Documentation technique" class="md-nav" data-md-level="1">
<label class="md-nav__title" for="__nav_5">
<span class="md-nav__icon md-icon"></span>
          Documentation technique
        </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../4_analyseExistant/">
        Analyse de L'existant
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../5_userStories/">
        User Stories
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../6_interface/">
        Interfaces
      </a>
</li>
<li class="md-nav__item md-nav__item--active">
<input class="md-nav__toggle md-toggle" data-md-toggle="toc" id="__toc" type="checkbox"/>
<label class="md-nav__link md-nav__link--active" for="__toc">
          Architecture
          <span class="md-nav__icon md-icon"></span>
</label>
<a class="md-nav__link md-nav__link--active" href="./">
        Architecture
      </a>
<nav aria-label="Table of contents" class="md-nav md-nav--secondary">
<label class="md-nav__title" for="__toc">
<span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
<ul class="md-nav__list" data-md-component="toc" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="#arborescence-de-fichier">
    Arborescence de fichier
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#docs">
    Docs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#travaildiplome_tissott">
    TravailDiplome_TISSOTT
  </a>
<nav aria-label="TravailDiplome_TISSOTT" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#packages">
    Packages
  </a>
<nav aria-label="Packages" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#qrcoder143">
    QRCoder.1.4.3
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#nethereum441">
    Nethereum.4.4.1
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#metroset_ui200">
    MetroSet_UI.2.0.0
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#newtonsoftjson1301">
    Newtonsoft.Json.13.0.1
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#travaildiplome_tissott_1">
    TravailDiplome_TISSOTT
  </a>
<nav aria-label="TravailDiplome_TISSOTT" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#appcontrollercs">
    AppController.cs
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#champs">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#methodes">
    Méthodes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur">
    Constructeur
  </a>
<nav aria-label="Constructeur" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#checkifsettingaresaved">
    CheckIfSettingAreSaved
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#savesettings">
    SaveSettings
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#showauthenticatordialogbox">
    ShowAuthenticatorDialogBox
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#blockchaincontrollercs">
    BlockchainController.cs
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constantes">
    Constantes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_1">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#methodes_1">
    Méthodes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_1">
    Constructeur
  </a>
<nav aria-label="Constructeur" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#createtransaction">
    CreateTransaction
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#decryptjsonfile">
    DecryptJSONFile
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#deletewallet">
    DeleteWallet
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#generatejsonfile">
    GenerateJSONFile
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#generatejsonfile_1">
    GenerateJSONFile
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getaccountfromprivatekey">
    GetAccountFromPrivateKey
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getallblocks">
    GetAllBlocks
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getalltransacfrompublicaddress">
    GetAllTransacFromPublicAddress
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getbalanceatallblocks">
    GetBalanceAtAllBlocks
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getlastblock">
    GetLastBlock
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getbalanceineth">
    GetBalanceInETH
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getpublicaddresswithwalletindex">
    GetPublicAddressWithWalletIndex
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getuserwallets">
    GetUserWallets
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#importaccountwithfile">
    ImportAccountWithFile
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#importaccountwithprivatekey">
    ImportAccountWithPrivateKey
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#isaddressvalid">
    isAddressValid
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#keystoredirectorycheck">
    KeystoreDirectoryCheck
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#settingscs">
    Settings.cs
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_2">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#methodes_2">
    Méthodes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_2">
    Constructeur
  </a>
<nav aria-label="Constructeur" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#getcontactpublickeywithindex">
    GetContactPublicKeyWithIndex
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#contactcs">
    Contact.cs
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_3">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_3">
    Constructeur
  </a>
<nav aria-label="Constructeur" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#jwtcontrollercs">
    JwtController.cs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#usercs">
    User.cs
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constantes_1">
    Constantes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_4">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_4">
    Constructeur
  </a>
<nav aria-label="Constructeur" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#walletcs">
    Wallet.cs
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_5">
    Constructeur
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#website">
    website
  </a>
<nav aria-label="website" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#docs_1">
    Docs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#site">
    site
  </a>
<nav aria-label="site" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#functionsphp">
    Functions.php
  </a>
<nav aria-label="Functions.php" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#createsecretkey">
    CreateSecretKey
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#checkauthenticator">
    CheckAuthenticator
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#functionconnexiondbphp">
    FunctionConnexionDB.php
  </a>
<nav aria-label="FunctionConnexionDB.php" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#getconnexion">
    GetConnexion
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#createuser">
    CreateUser
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getusersecretkey">
    GetUserSecretKey
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#checkuserlogin">
    CheckUserLogin
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getuserid">
    GetUserId
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#api">
    API
  </a>
<nav aria-label="API" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#authenticatorphp">
    authenticator.php
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#loginphp">
    Login.php
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#tokenauthenticatorphp">
    TokenAuthenticator.php
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#tokencreatorphp">
    TokenCreator.php
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#assets">
    Assets
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#connexion">
    Connexion
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#createacount">
    CreateAcount
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#download">
    Download
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#stylesheets">
    stylesheets
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#indexphp">
    Index.php
  </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../8_outilsExterne/">
        Outils et librairies externes
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../9_installationEnvironnement/">
        Installation de l'environnement
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../10_EncryptionBdd/">
        Encryption de base de données
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../docClasse/">
        Description Classes
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../Tests/">
        Tests
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../conclusion/">
        Conclusion
      </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item md-nav__item--nested">
<input class="md-nav__toggle md-toggle" data-md-toggle="__nav_6" id="__nav_6" type="checkbox"/>
<label class="md-nav__link" for="__nav_6">
          Annexes
          <span class="md-nav__icon md-icon"></span>
</label>
<nav aria-label="Annexes" class="md-nav" data-md-level="1">
<label class="md-nav__title" for="__nav_6">
<span class="md-nav__icon md-icon"></span>
          Annexes
        </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../JournalDeBord/">
        Journal de bord
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../tableDesIllustrations/">
        Table des illustrations
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../planningAnnexe/">
        Planning
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../codeSource/">
        Code source
      </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</div>
</div>
</div>
<div class="md-sidebar md-sidebar--secondary" data-md-component="sidebar" data-md-type="toc">
<div class="md-sidebar__scrollwrap">
<div class="md-sidebar__inner">
<nav aria-label="Table of contents" class="md-nav md-nav--secondary">
<label class="md-nav__title" for="__toc">
<span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
<ul class="md-nav__list" data-md-component="toc" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="#arborescence-de-fichier">
    Arborescence de fichier
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#docs">
    Docs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#travaildiplome_tissott">
    TravailDiplome_TISSOTT
  </a>
<nav aria-label="TravailDiplome_TISSOTT" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#packages">
    Packages
  </a>
<nav aria-label="Packages" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#qrcoder143">
    QRCoder.1.4.3
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#nethereum441">
    Nethereum.4.4.1
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#metroset_ui200">
    MetroSet_UI.2.0.0
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#newtonsoftjson1301">
    Newtonsoft.Json.13.0.1
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#travaildiplome_tissott_1">
    TravailDiplome_TISSOTT
  </a>
<nav aria-label="TravailDiplome_TISSOTT" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#appcontrollercs">
    AppController.cs
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#champs">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#methodes">
    Méthodes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur">
    Constructeur
  </a>
<nav aria-label="Constructeur" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#checkifsettingaresaved">
    CheckIfSettingAreSaved
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#savesettings">
    SaveSettings
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#showauthenticatordialogbox">
    ShowAuthenticatorDialogBox
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#blockchaincontrollercs">
    BlockchainController.cs
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constantes">
    Constantes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_1">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#methodes_1">
    Méthodes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_1">
    Constructeur
  </a>
<nav aria-label="Constructeur" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#createtransaction">
    CreateTransaction
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#decryptjsonfile">
    DecryptJSONFile
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#deletewallet">
    DeleteWallet
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#generatejsonfile">
    GenerateJSONFile
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#generatejsonfile_1">
    GenerateJSONFile
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getaccountfromprivatekey">
    GetAccountFromPrivateKey
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getallblocks">
    GetAllBlocks
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getalltransacfrompublicaddress">
    GetAllTransacFromPublicAddress
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getbalanceatallblocks">
    GetBalanceAtAllBlocks
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getlastblock">
    GetLastBlock
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getbalanceineth">
    GetBalanceInETH
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getpublicaddresswithwalletindex">
    GetPublicAddressWithWalletIndex
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getuserwallets">
    GetUserWallets
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#importaccountwithfile">
    ImportAccountWithFile
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#importaccountwithprivatekey">
    ImportAccountWithPrivateKey
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#isaddressvalid">
    isAddressValid
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#keystoredirectorycheck">
    KeystoreDirectoryCheck
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#settingscs">
    Settings.cs
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_2">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#methodes_2">
    Méthodes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_2">
    Constructeur
  </a>
<nav aria-label="Constructeur" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#getcontactpublickeywithindex">
    GetContactPublicKeyWithIndex
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#contactcs">
    Contact.cs
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_3">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_3">
    Constructeur
  </a>
<nav aria-label="Constructeur" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#jwtcontrollercs">
    JwtController.cs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#usercs">
    User.cs
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constantes_1">
    Constantes
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#champs_4">
    Champs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_4">
    Constructeur
  </a>
<nav aria-label="Constructeur" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#walletcs">
    Wallet.cs
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#constructeur_5">
    Constructeur
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#website">
    website
  </a>
<nav aria-label="website" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#docs_1">
    Docs
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#site">
    site
  </a>
<nav aria-label="site" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#functionsphp">
    Functions.php
  </a>
<nav aria-label="Functions.php" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#createsecretkey">
    CreateSecretKey
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#checkauthenticator">
    CheckAuthenticator
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#functionconnexiondbphp">
    FunctionConnexionDB.php
  </a>
<nav aria-label="FunctionConnexionDB.php" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#getconnexion">
    GetConnexion
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#createuser">
    CreateUser
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getusersecretkey">
    GetUserSecretKey
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#checkuserlogin">
    CheckUserLogin
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#getuserid">
    GetUserId
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#api">
    API
  </a>
<nav aria-label="API" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#authenticatorphp">
    authenticator.php
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#loginphp">
    Login.php
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#tokenauthenticatorphp">
    TokenAuthenticator.php
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#tokencreatorphp">
    TokenCreator.php
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#assets">
    Assets
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#connexion">
    Connexion
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#createacount">
    CreateAcount
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#download">
    Download
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#stylesheets">
    stylesheets
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#indexphp">
    Index.php
  </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</div>
</div>
</div>
<div class="md-content" data-md-component="content">
<article class="md-content__inner md-typeset">
<h1 id="architecture">Architecture</h1>
<h2 id="arborescence-de-fichier">Arborescence de fichier</h2>
<p>L'arborescence est une partie importante pour tout type de projet, puisqu'il fait référence à l'ensemble des différentes compositions de projets et de leurs liens. Il est important de spécifier ici que dans cette structure on voit trois racines. Il s'agit de la partie "docs", "TravailDiplome_TISSOTT" et de "website", qui sont des racines.</p>
<p>La répertoire "docs" contient la documentation.</p>
<p>La partie "TravailDiplome_TISSOTT" qui est la racine de mon application est divisée en deux sections. La section des classes ainsi que celle des vues. Il était important de séparer ces deux parties pour mettre en avant leur différence fonctionnelle. Mes classes ne sont pas au même niveau hiérarchique que mes vues puisqu'il s'agit de la partie qui va "être" utilisé dans mes vues (views).</p>
<p>La partie "website" qui est la racine de mon site web est divisée en plusieurs parties. Il était important de séparer les différentes structures pour optimiser au mieux l'accessibilité aux contenus. 
<div class="highlight"><pre><span></span><code>+-- docs
|   +-- main.py
|   +-- planningPervisionnelV2.xlsx
|   +-- docs
|       +-- img
|       +-- Fichiers MarkDown...
+-- TravailDiplome_TISSOTT
|    +-- packages
|        +-- QRCoder.1.4.3
|        +-- Nethereum.4.4.1
|        +-- MetroSet_UI.2.0.0
|        +-- Newtonsoft.Json.13.0.1
|   +-- TravailDiplome_TISSOTT
|       +-- AppController.cs
|       +-- BlockchainController.cs
|       +-- Contact.cs
|       +-- views
|           +-- frmAddModifyContact.cs
|           +-- frmAddModifyContact.Designer.cs
|           +-- frmAdresse.cs
|           +-- frmAdresse.Designer.cs
|           +-- frmMain.cs
|           +-- frmAuthenticator.cs
|           +-- frmAuthenticator.Designer.cs
|           +-- frmAuthenticatorPopUp.cs
|           +-- frmAuthenticatorPopUp.Designer.cs
|           +-- frmContact.cs
|           +-- frmContact.Designer.cs
|           +-- frmEnvoi.cs
|           +-- frmEnvoi.Designer.cs
|           +-- frmGestionPortefeuilles.cs
|           +-- frmGestionPortefeuilles.Designer.cs
|           +-- frmImportWalletFromFile.cs
|           +-- frmImportWalletFromFile.Designer.cs
|           +-- frmImportWalletFromKey.cs
|           +-- frmImportWalletFromKey.Designer.cs
|           +-- frmLogin.cs
|           +-- frmLogin.Designer.cs
|           +-- frmMain.cs
|           +-- frmMain.Designer.cs
|           +-- frmMonCompte.cs
|           +-- frmMonCompte.Designer.cs
|           +-- frmParametres.cs
|           +-- frmParametres.Designer.cs
|       +-- JwtController.cs
|       +-- Program.cs
|       +-- Settings.cs
|       +-- User.cs
|       +-- Wallet.cs
|   +-- TravailDiplome_TISSOTT.sln
+-- website
|   +-- site
|       +-- index.php
|       +-- Functions.php
|       +-- FunctionConnexionDB.php
|       +-- API
|           +-- authenticator.php
|           +-- login.php
|           +-- tokenAuthenticator.php
|           +-- tokenCreator.php
|    +-- docs
|       +-- connexion.md
|       +-- createAccount.md
|       +-- download.md
|       +-- inedx.md
|       +-- stylesheets
|          +-- extra.css
</code></pre></div></p>
<p>Ce qui suit fait référence à l'arborescence ci-dessus. J'explique en détail ce que représente chaque structure de mon arborescence afin que cela soit clair et détaillé. Puisque, comme on le voit sur l'arborescence, il y a trois racines structurées comme suit.</p>
<h2 id="docs">Docs</h2>
<p>Dans ce dossier on y trouve des fichiers qui sont utilisés afin d'uniformiser les PDF rendus par tous les élèves. Dans le dossier "docs" de celle-ci, on y trouve un dossier "img" qui est le dossier qui comporte la totalité des images que j'utilise dans mon rapport de travail de diplôme ainsi que des fichiers générés automatiquement par MarkDown.</p>
<h2 id="travaildiplome_tissott">TravailDiplome_TISSOTT</h2>
<h3 id="packages">Packages</h3>
<h4 id="qrcoder143">QRCoder.1.4.3</h4>
<p>Librairie que j'utilise pour générer des QRcode en C#.</p>
<h4 id="nethereum441">Nethereum.4.4.1</h4>
<p>Wrapper c# de la libraire Web3 JS permet la communication avec la blockchaine, celle-ci a également un module permettant d'encrypter les portefeuilles en format "JSON".</p>
<h4 id="metroset_ui200">MetroSet_UI.2.0.0</h4>
<p>Librairie que j'utilise pour appliquer un thème aux différentes vues de mon application, ce qui rend le visuel plus actuel.</p>
<h4 id="newtonsoftjson1301">Newtonsoft.Json.13.0.1</h4>
<p>Ce package permet la Sérialisation et désérialisation des objets présents de mon application. </p>
<h3 id="travaildiplome_tissott_1">TravailDiplome_TISSOTT</h3>
<p>Répertoire qui comporte la totalité du code pour mon application client C#.</p>
<figure id="fig66" style="width: 75%">
<img alt="Diagramme de classes" src=".././img/DiagrammeClasse.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 66]:</span><b>Diagramme de classes</b> </figcaption>
</figure>
<h4 id="appcontrollercs">AppController.cs</h4>
<p>Cette classe représente le modèle de données nécessaires au bon fonctionnement du programme, c'est cet objet qui est transmis entre les différentes vues lors de leurs instanciations. </p>
<h3 id="champs">Champs</h3>
<ul>
<li>User : Objet de type User.</li>
<li>Bc : Objet de type BlockchainController.</li>
<li>Settings : Objet de type Settings.</li>
</ul>
<h3 id="methodes">Méthodes</h3>
<h3 id="constructeur">Constructeur</h3>
<p>Un "AppController" est caractérisé par trois valeurs. Il s'agit d'un "User" user, d'un "BlockchainController" bc et d'un "Settings" settings.</p>
<p>Un constructeur est mis en place avec un paramètre "string" userEmail. Dans celui-ci on indique que le "User" devient un nouvel utilisateur (new User) avec comme paramètre le userEmail. Enfin j'appelle la méthode <a href="#checkifsettingaresaved">CheckIfSettingsAreSaved</a>.</p>
<h4 id="checkifsettingaresaved">CheckIfSettingAreSaved</h4>
<p>Cette méthode permet de vérifier si des paramètres ont déjà été enregistrés. Dans le cas où ça le serait, il instancie la classe "Settings" à l'aide de l'objet sérialisé présent dans le répertoire propre à chaque utilisateur.</p>
<h4 id="savesettings">SaveSettings</h4>
<p>Cette méthode permet de sauvegarder les paramètres en sérialisant la classe "Settings" dans le répertoire de l'utilisateur connecté, lors de la sélection.</p>
<h4 id="showauthenticatordialogbox">ShowAuthenticatorDialogBox</h4>
<p>Cette méthode prend en paramètre une "From" frmOwner.</p>
<p>Cette méthode permet d'afficher la "pop-up" Authenticator et d'attendre un résultat de celle-ci.</p>
<p>Enfin je retourne le résultat de celle-ci.</p>
<h4 id="blockchaincontrollercs">BlockchainController.cs</h4>
<h3 id="constantes">Constantes</h3>
<ul>
<li>BLOCKCHAIN_URL : URL pointant sur la blockchain.</li>
</ul>
<h3 id="champs_1">Champs</h3>
<ul>
<li>Wallets : Liste d'objets de type Wallet.</li>
</ul>
<h3 id="methodes_1">Méthodes</h3>
<h3 id="constructeur_1">Constructeur</h3>
<p>Ce constructeur permet d'instancier l'objet Web3 qui communique avec la blockchain.</p>
<h4 id="createtransaction">CreateTransaction</h4>
<p>Cette méthode prend en paramètre un "string" privateKey, un "string" publiKey et une "decimal" amount.</p>
<p>Son but est de permettre la création d'une transaction par l'utilisateur à une tierce personne. C'est pourquoi il faut renseigner l'adresse publique ainsi que le montant. L'adresse privée permet de signer la transaction sur la blockchain.</p>
<p>Réponse de la blockchain  :
<div class="highlight"><pre><span></span><code><span class="p">{</span><span class="w"></span>
<span class="w">    </span><span class="nt">"transactionHash"</span><span class="p">:</span><span class="s2">"0x7cac6796d856fe83114ef61ad2372b8d13d91d476145bb57d46cdadd7e1f0655"</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"transactionIndex"</span><span class="p">:</span><span class="s2">"0x0"</span><span class="p">,</span><span class="nt">"blockHash"</span><span class="p">:</span><span class="s2">"0x2e52ff60b3cb911a761bea8b7ea8fe9d334494dbceed997bbbeab1135f286392"</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"blockNumber"</span><span class="p">:</span><span class="s2">"0x2"</span><span class="p">,</span><span class="nt">"from"</span><span class="p">:</span><span class="s2">"0xf39fd6e51aad88f6f4ce6ab8827279cfffb92266"</span><span class="p">,</span><span class="nt">"to"</span><span class="p">:</span><span class="s2">"0x90f79bf6eb2c4f870365e785982e1f101e93b906"</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"cumulativeGasUsed"</span><span class="p">:</span><span class="s2">"0x5208"</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"gasUsed"</span><span class="p">:</span><span class="s2">"0x5208"</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"effectiveGasPrice"</span><span class="p">:</span><span class="s2">"0x77359400"</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"contractAddress"</span><span class="p">:</span><span class="kc">null</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"status"</span><span class="p">:</span><span class="s2">"0x1"</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"logs"</span><span class="p">:[],</span><span class="w"></span>
<span class="w">    </span><span class="nt">"type"</span><span class="p">:</span><span class="s2">"0x0"</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"logsBloom"</span><span class="p">:</span><span class="s2">"0x000000000...."</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"root"</span><span class="p">:</span><span class="kc">null</span><span class="p">}</span><span class="w"></span>
</code></pre></div></p>
<h4 id="decryptjsonfile">DecryptJSONFile</h4>
<p>Cette méthode prend en paramètre un "string" password et un "string" jsonPath.</p>
<p>Son but est de pouvoir prendre un portefeuille crypté sous forme de fichier "JSON" à un emplacement spécifique (jsonPath) et de pouvoir le décrypter à l'aide du code (password) afin d'y retirer les informations nécessaires. Il s'agit de préciser ici que le code doit être le même que celui utilisé pour son portefeuille à la création/importation.</p>
<h4 id="deletewallet">DeleteWallet</h4>
<p>Cette méthode prend en paramètre un "int" walletIndex et un "string" emailUser.</p>
<p>Son utilité est de pouvoir supprimer un portefeuille de sa liste "Wallets" de cette classe. </p>
<p>Pour ce faire, on cherche le "Wallet" suivant son index, ensuite on y extrait son champ "path" ainsi que son "name".</p>
<p>Enfin, on parcourt le dossier pour trouver tout fichier qui comporte le nom demandé. Sans oublier de le supprimer de notre Liste de portefeuille à l'index spécifié en paramètre.</p>
<h4 id="generatejsonfile">GenerateJSONFile</h4>
<p>Cette méthode prend en paramètre un "string" password, un "string" name et un "string" accountName.</p>
<p>Le but est de générer un fichier "JSON" dans un dossier spécifié. Il est également important de regarder si le fichier existe déjà, dans ce cas on fait apparaître un message pour informer l'utilisateur. Dans le cas contraire, on crée le fichier "JSON" comportant les informations cryptées et un fichier "txt" qui contient la clé publique.</p>
<h4 id="generatejsonfile_1">GenerateJSONFile</h4>
<p>Cette méthode prend en paramètre en plus de celle ci-dessus un "Account" account. Ce type est nécessaire lors de l'importation d'un fichier "JSON", puisqu’on est obligé de générer un "Account" pour récupérer la clé publique de ce portefeuille.</p>
<h4 id="getaccountfromprivatekey">GetAccountFromPrivateKey</h4>
<p>Cette méthode prend en paramètre un "string" privateKey.</p>
<p>Son utilité est de pouvoir créer et retourner un compte (Account) en utilisant sa clé privée.</p>
<h4 id="getallblocks">GetAllBlocks</h4>
<p>Retourne tous les blocs, avec leurs transactions, présents dans la blockchain.</p>
<p>Requête sur la blockchain :
<div class="highlight"><pre><span></span><code><span class="p">{</span><span class="w"></span>
<span class="nt">"id"</span><span class="p">:</span><span class="mi">1</span><span class="p">,</span><span class="w"></span>
<span class="nt">"jsonrpc"</span><span class="p">:</span><span class="s2">"2.0"</span><span class="p">,</span><span class="w"></span>
<span class="nt">"method"</span><span class="p">:</span><span class="s2">"eth_getBlockByNumber"</span><span class="p">,</span><span class="w"></span>
<span class="nt">"params"</span><span class="p">:[</span><span class="s2">"0x1"</span><span class="p">,</span><span class="kc">true</span><span class="p">]</span><span class="w"></span>
<span class="p">}</span><span class="w"></span>
</code></pre></div>
Réponse de la blockchain :
<div class="highlight"><pre><span></span><code><span class="p">{</span><span class="w"></span>
<span class="w">    </span><span class="nt">"jsonrpc"</span><span class="p">:</span><span class="s2">"2.0"</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"id"</span><span class="p">:</span><span class="mi">1</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"result"</span><span class="p">:</span><span class="w"></span>
<span class="w">    </span><span class="p">{</span><span class="w"></span>
<span class="w">        </span><span class="nt">"number"</span><span class="p">:</span><span class="s2">"0x0"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"hash"</span><span class="p">:</span><span class="s2">"0x8dc17285c0e2786a1bb77fe5bc5d20d35ecae62821574791504ca9fd51033209"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"parentHash"</span><span class="p">:</span><span class="s2">"0x0000000000000000000000000000000000000000000000000000000000000000"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"nonce"</span><span class="p">:</span><span class="s2">"0x0000000000000042"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"mixHash"</span><span class="p">:</span><span class="s2">"0x0000000000000000000000000000000000000000000000000000000000000000"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"sha3Uncles"</span><span class="p">:</span><span class="s2">"0x1dcc4de8dec75d7aab85b567b6ccd41ad312451b948a7413f0a142fd40d49347"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"logsBloom"</span><span class="p">:</span><span class="s2">"0x000000000......"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"transactionsRoot"</span><span class="p">:</span><span class="s2">"0x56e81f171bcc55a6ff8345e692c0f86e5b48e01b996cadc001622fb5e363b421"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"stateRoot"</span><span class="p">:</span><span class="s2">"0x950cc3b1c26a9cd52a81793977d91eb11603c310375216ccacc4ffe18af72959"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"receiptsRoot"</span><span class="p">:</span><span class="s2">"0x56e81f171bcc55a6ff8345e692c0f86e5b48e01b996cadc001622fb5e363b421"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"miner"</span><span class="p">:</span><span class="s2">"0x0000000000000000000000000000000000000000"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"difficulty"</span><span class="p">:</span><span class="s2">"0x1"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"totalDifficulty"</span><span class="p">:</span><span class="s2">"0x1"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"extraData"</span><span class="p">:</span><span class="s2">"0x1234"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"size"</span><span class="p">:</span><span class="s2">"0x204"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"gasLimit"</span><span class="p">:</span><span class="s2">"0x1c9c380"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"gasUsed"</span><span class="p">:</span><span class="s2">"0x0"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"timestamp"</span><span class="p">:</span><span class="s2">"0x62a19bd2"</span><span class="p">,</span><span class="w"></span>
<span class="w">        </span><span class="nt">"transactions"</span><span class="p">:[],</span><span class="w"></span>
<span class="w">        </span><span class="nt">"uncles"</span><span class="p">:[],</span><span class="w"></span>
<span class="w">        </span><span class="nt">"baseFeePerGas"</span><span class="p">:</span><span class="s2">"0x3b9aca00"</span><span class="w"></span>
<span class="w">    </span><span class="p">}</span><span class="w"></span>
<span class="p">}</span><span class="w"></span>
</code></pre></div></p>
<h4 id="getalltransacfrompublicaddress">GetAllTransacFromPublicAddress</h4>
<p>Cette méthode prend en paramètre un "string" publicAdress.</p>
<p>Son utilité est de pouvoir obtenir toutes les transactions effectuées avec un certain portefeuille. Pour y arriver, on parcourt la liste des blocs fournie par la méthode <a href="#getallblocks">GetAllBlocks</a> pour y extraire toutes les transactions où l'adresse publique est présente. </p>
<p>Enfin, on retourne le dictionnaire de transaction "myTransac".</p>
<h4 id="getbalanceatallblocks">GetBalanceAtAllBlocks</h4>
<p>Cette méthode prend en paramètre un "string" adresse.</p>
<p>Pour chaque bloc présent dans la blockchain, on effectue une requête "GetBalance" ce qui nous permet d'extraire l'évolution de la quantité d'Etherum présente dans un portefeuille.</p>
<p>Elle retourne un dictionnaire avec comme clé le "TimeStamp" de chaque bloc et comme valeur associée la quantité d'Etherum disponible.</p>
<h4 id="getlastblock">GetLastBlock</h4>
<p>Cette méthode asynchrone prend en paramètre un "string" publicAddress.</p>
<p>Elle retourne le dernier id du bloc stocké dans la blockchain.</p>
<p>Réponse de la blockchain  :
<div class="highlight"><pre><span></span><code><span class="p">{</span><span class="w"></span>
<span class="w">    </span><span class="nt">"id"</span><span class="p">:</span><span class="mi">1</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"jsonrpc"</span><span class="p">:</span><span class="s2">"2.0"</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"method"</span><span class="p">:</span><span class="s2">"eth_blockNumber"</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"params"</span><span class="p">:[]</span><span class="w"></span>
<span class="p">}</span><span class="w"></span>
</code></pre></div></p>
<p>Réponse de la blockchain  :
<div class="highlight"><pre><span></span><code><span class="p">{</span><span class="w"></span>
<span class="w">    </span><span class="nt">"jsonrpc"</span><span class="p">:</span><span class="s2">"2.0"</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"id"</span><span class="p">:</span><span class="mi">1</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"result"</span><span class="p">:</span><span class="s2">"0x2"</span><span class="w"></span>
<span class="p">}</span><span class="w"></span>
</code></pre></div></p>
<h4 id="getbalanceineth">GetBalanceInETH</h4>
<p>Cette méthode prend en paramètre un "string" adresse.</p>
<p>Son utilité est qu'elle prend la balance d'une clé publique en "wei" et la convertie en "Eth".</p>
<p>Requête sur la blockchain :
<div class="highlight"><pre><span></span><code><span class="p">{</span><span class="w"></span>
<span class="w">    </span><span class="nt">"id"</span><span class="p">:</span><span class="mi">1</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"jsonrpc"</span><span class="p">:</span><span class="s2">"2.0"</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"method"</span><span class="p">:</span><span class="s2">"eth_getBalance"</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"params"</span><span class="p">:[</span><span class="s2">"0xf39Fd6e51aad88F6F4ce6aB8827279cffFb92266"</span><span class="p">,</span><span class="s2">"latest"</span><span class="p">]</span><span class="w"></span>
<span class="p">}</span><span class="w"></span>
</code></pre></div></p>
<p>Réponse de la blockchain :
<div class="highlight"><pre><span></span><code><span class="p">{</span><span class="w"></span>
<span class="w">    </span><span class="nt">"jsonrpc"</span><span class="p">:</span><span class="s2">"2.0"</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"id"</span><span class="p">:</span><span class="mi">1</span><span class="p">,</span><span class="w"></span>
<span class="w">    </span><span class="nt">"result"</span><span class="p">:</span><span class="s2">"0x21d0452374bd846c000"</span><span class="w"></span>
<span class="p">}</span><span class="w"></span>
</code></pre></div></p>
<h4 id="getpublicaddresswithwalletindex">GetPublicAddressWithWalletIndex</h4>
<p>Cette méthode prend en paramètre un "int" index.</p>
<p>Son utilité est de pouvoir retourner la clé publique à un index spécifié (publicAddress) dans la Liste "Wallets".</p>
<h4 id="getuserwallets">GetUserWallets</h4>
<p>Cette méthode prend en paramètre un "string" path.</p>
<p>Son utilité est de pouvoir instancier les différents portefeuilles appartenant à l'utilisateur connecté dans la Liste "Wallets".</p>
<p>Enfin, je retourne cette variable "result" qui contient une Liste de wallet.</p>
<h4 id="importaccountwithfile">ImportAccountWithFile</h4>
<p>Cette méthode prend en paramètre un "string" password, un "string" path, un "string" name et un "string" accountName.</p>
<p>Son but est de pouvoir instancier une variable de type "Account" nécessaire à la méthode <a href="#generatejsonfile">GenerateJsonfile</a>. Mais avant de pouvoir faire cela, il est nécessaire d'utiliser la méthode <a href="#decryptjsonfile">DecryptJSONFile</a>.</p>
<h4 id="importaccountwithprivatekey">ImportAccountWithPrivateKey</h4>
<p>Cette méthode prend en paramètre un "string" privateKey, un "string" password, un "string" email et un "string" walletName.</p>
<p>Son but est de pouvoir instancier une variable de type "Account" nécessaire à la méthode <a href="#generatejsonfile">GenerateJsonfile</a>.</p>
<h4 id="isaddressvalid">isAddressValid</h4>
<p>Cette méthode prend en paramètre un "string" privateKey.</p>
<p>Son but est de vérifié si l'adresse publique on non.</p>
<p>Elle retourne "True" si valide sinon "False".</p>
<h4 id="keystoredirectorycheck">KeystoreDirectoryCheck</h4>
<p>Cette méthode prend en paramètre un "string" email.</p>
<p>Son but est de vérifier si le répertoire devant contenir les différents portefeuilles de l'utilisateur a été préalablement créé.</p>
<h4 id="settingscs">Settings.cs</h4>
<p>Cette classe permet de lister les différents contacts créés par l'utilisateur. Permets également d'enregistrer la devise utilisée par l'application.</p>
<h3 id="champs_2">Champs</h3>
<ul>
<li>Contacts : Liste d'objets de type Contact.</li>
<li>currency : La devise utilisée par l'utilisateur.</li>
</ul>
<h3 id="methodes_2">Méthodes</h3>
<h3 id="constructeur_2">Constructeur</h3>
<p>Dans ce constructeur j'instancie la devise (currency) à "USD" par défaut. De plus, je créer une nouvelle liste d'objet "Contact" vide.</p>
<h4 id="getcontactpublickeywithindex">GetContactPublicKeyWithIndex</h4>
<p>Cette méthode prend en paramètre un "int" index.</p>
<p>Elle retourne un "string" avec la publicKey d'un contact dans la Liste "Contacts" à l'index spécifié.</p>
<h4 id="contactcs">Contact.cs</h4>
<p>Cette classe représente la structure de donnée d'un contact nécessaire à mon application.</p>
<h3 id="champs_3">Champs</h3>
<ul>
<li>name : Nom du contact.</li>
<li>PublicKey : Clé publique du contact.</li>
</ul>
<h3 id="constructeur_3">Constructeur</h3>
<p>Ce constructeur prend en paramètre un "string" name et un "string" publicKey, pour assigné directement les valeurs aux champs.</p>
<h4 id="jwtcontrollercs">JwtController.cs</h4>
<p>Classe statique permettant l'échange d'informations entre l'API PHP et le client.</p>
<h4 id="usercs">User.cs</h4>
<p>Cette classe représente la structure de donnée d'un utilisateur nécessaire à mon application.</p>
<h3 id="constantes_1">Constantes</h3>
<h3 id="champs_4">Champs</h3>
<ul>
<li>Email : Email avec lequel l'utilisateur s'est connecté.</li>
<li>Token : Token JWT que reçoit l'utilisateur une fois connecté.</li>
</ul>
<h3 id="constructeur_4">Constructeur</h3>
<p>Ce constructeur prend en paramètre un "string" email, afin d'assigne directement la valeur au champ Email a l'instanciation de cette classe.</p>
<h4 id="walletcs">Wallet.cs</h4>
<p>Cette classe est utilisée pour stocker les portefeuilles dans l'application. Celle-ci, est constituée d'un nom, du chemin d'accès qui pointe sur le fichier "JSON" dans lequel les données sont encryptées et stockées, ainsi que la clé publique ce qui permet d'éviter de devoir décrypter le portefeuille pour un simple accès à la clé publique.</p>
<h3 id="constructeur_5">Constructeur</h3>
<p>Ce constructeur a comme paramètres un string nom ("Name"), un string "publicKey" et d'un string "path".</p>
<p>Celui-ci permet d'instancier un Wallet et d'assigner les valeurs.</p>
<h2 id="website">website</h2>
<p>Il s’agit du dossier qui contient les fichiers qui composent mon site web, pour permettre de se créer un compte ainsi que se connecter afin de pouvoir obtenir un code Authenticator ainsi que de permettre le téléchargement de mon application.</p>
<h3 id="docs_1">Docs</h3>
<p>Ce dossier contient les fichiers nécessaires pour générer le site à l'aide de "MkDocs".</p>
<h3 id="site">site</h3>
<p>Il s'agit du dossier du site généré automatiquement par MarkDown</p>
<h4 id="functionsphp">Functions.php</h4>
<h5 id="createsecretkey">CreateSecretKey</h5>
<p>Cette fonction prend en paramètre le compte ($account) qui fait référence à l'email de l'utilisateur.</p>
<p>Son but est de pouvoir créer une clé unique qui sera nécessaire à l'API de "Google Authenticator".</p>
<p>Elle retourne une clé ($secret) qui est générée par la librairie "\Dolondro\GoogleAuthenticator\".</p>
<h5 id="checkauthenticator">CheckAuthenticator</h5>
<p>Cette fonction prend en paramètre deux valeurs, une clé secrète ($secretKey) et un mot de passe ($code).</p>
<p>Son but est de vérifier si la clé secrète ($secretKey) est identique au mot de passe($code) en temps réel.</p>
<p>Elle retourne "True" si le code introduit par l'utilisateur est valide ou "False" dans le cas contraire.</p>
<h4 id="functionconnexiondbphp">FunctionConnexionDB.php</h4>
<h5 id="getconnexion">GetConnexion</h5>
<p>Cette fonction sert à pouvoir se connecter à la base de données. Pour ce faire, elle génère un objet PDO qui est connecté à la base de données.</p>
<p>Elle retourne un objet PDO qui est connecté à la base de données.</p>
<h5 id="createuser">CreateUser</h5>
<p>Cette fonction prend en paramètre trois valeurs, un email($email), un mot de passe ($password) et une clé secrète ($secretKey).</p>
<p>Son but est de permettre d'insérer un utilisateur dans la base de données.</p>
<h5 id="getusersecretkey">GetUserSecretKey</h5>
<p>Cette fonction prend en paramètre l'email ($email) de l'utilisateur.</p>
<p>Son but est de pouvoir prendre sa clé privée dans la base de données qui fait référence à l'email de l'utilisateur qui est unique.</p>
<p>Elle retourne un tableau à une dimension qui fait référence à la clé secrète associée à l'utilisateur.</p>
<h5 id="checkuserlogin">CheckUserLogin</h5>
<p>Cette fonction prend en paramètre deux valeurs, le mail de l'utilisateur ($email) et son mot de passe ($password).</p>
<p>Son but est de pouvoir contrôler la connexion de l'utilisateur. Pour ce faire, on sélectionne l'utilisateur qui fait référence au mail et le mot de passe en question.</p>
<p>Elle retourne un tableau à une dimension qui détient la valeur en "string" de la clé secrète de l'utilisateur associé.</p>
<h5 id="getuserid">GetUserId</h5>
<p>Cette fonction prend en paramètre le mail de l'utilisateur ($email).</p>
<p>Son but est de pouvoir sélectionner l'identifiant (idUser) de l'utilisateur par rapport à son mail ($email).</p>
<p>Elle retourne donc un tableau à une dimension avec comme valeur en "string" l'identifiant de l'utilisateur en question.</p>
<h4 id="api">API</h4>
<h5 id="authenticatorphp">authenticator.php</h5>
<p>Il s’agit d’un fichier PHP qui permet la vérification du code Google Authenticator fournie par l’utilisateur.</p>
<h5 id="loginphp">Login.php</h5>
<p>Il s’agit d’un fichier PHP qui permet de savoir si l’utilisateur en question a bien mit les données qui lui correspond. Il s’agit donc de son nom d’utilisateur et de son mot de passe.</p>
<h5 id="tokenauthenticatorphp">TokenAuthenticator.php</h5>
<p>Il s’agit d’un fichier PHP qui permet de vérifier le token.</p>
<h5 id="tokencreatorphp">TokenCreator.php</h5>
<p>Il s’agit d’un fichier PHP qui permet de créer le token.</p>
<h4 id="assets">Assets</h4>
<p>Génération automatique de ces dossiers par MarkDown.</p>
<h4 id="connexion">Connexion</h4>
<p>Ce dossier contient un fichier PHP qui permet de se connecter au site grâce aux données enregistrées par l’utilisateur.</p>
<h4 id="createacount">CreateAcount</h4>
<p>Ce dossier contient un fichier PHP qui permet de créer un utilisateur.</p>
<h4 id="download">Download</h4>
<p>Ce dossier contient un fichier PHP qui permet à l’utilisateur connecter de pouvoir télécharger mon application en format ".msi".</p>
<h4 id="stylesheets">stylesheets</h4>
<p>Ce dossier contient le fichier CSS généré par MarkDown.</p>
<h4 id="indexphp">Index.php</h4>
<p>Fichier PHP qui est la page d’accueil de mon site. Une explication de mon projet est mise en place pour informer l’utilisateur de quoi il s’agit. Dans le cas où la personne serait intéressée, j’avertis que pour cela il doit créer un compte, pour ensuite s'y connecter afin de pouvoir télécharger le fichier d'installation.</p>
</article>
</div>
</div>
</main>
<footer class="md-footer">
<nav aria-label="Footer" class="md-footer__inner md-grid">
<a aria-label="Previous: Interfaces" class="md-footer__link md-footer__link--prev" href="../6_interface/" rel="prev">
<div class="md-footer__button md-icon">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12z"></path></svg>
</div>
<div class="md-footer__title">
<div class="md-ellipsis">
<span class="md-footer__direction">
                Previous
              </span>
              Interfaces
            </div>
</div>
</a>
<a aria-label="Next: Outils et librairies externes" class="md-footer__link md-footer__link--next" href="../8_outilsExterne/" rel="next">
<div class="md-footer__title">
<div class="md-ellipsis">
<span class="md-footer__direction">
                Next
              </span>
              Outils et librairies externes
            </div>
</div>
<div class="md-footer__button md-icon">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M4 11v2h12l-5.5 5.5 1.42 1.42L19.84 12l-7.92-7.92L10.5 5.5 16 11H4z"></path></svg>
</div>
</a>
</nav>
<div class="md-footer-meta md-typeset">
<div class="md-footer-meta__inner md-grid">
<div class="md-footer-copyright">
        
        
          Made with
          <a href="https://squidfunk.github.io/mkdocs-material/" rel="noopener" target="_blank">
            Material for MkDocs
          </a>
 ... <a class="link--pdf-download" download href="../pdf/document.pdf" title="PDF">download PDF</a></div>
</div>
</div>
</footer>
</div>
<div class="md-dialog" data-md-component="dialog">
<div class="md-dialog__inner md-typeset"></div>
</div>
<script id="__config" type="application/json">{"base": "..", "features": [], "translations": {"clipboard.copy": "Copy to clipboard", "clipboard.copied": "Copied to clipboard", "search.config.lang": "en", "search.config.pipeline": "trimmer, stopWordFilter", "search.config.separator": "[\\s\\-]+", "search.placeholder": "Search", "search.result.placeholder": "Type to start searching", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.term.missing": "Missing", "select.version.title": "Select version"}, "search": "../assets/javascripts/workers/search.fcfe8b6d.min.js", "version": null}</script>
<script src="../assets/javascripts/bundle.b1047164.min.js"></script>
<script src="https://unpkg.com/mermaid@8.5.1/dist/mermaid.min.js"></script>
</body>
</html>